"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GenerateUlLiFromTree = exports.getFileType = exports.createFile = exports.readdir = exports.lstat = exports.log = void 0;
var chalk_1 = __importDefault(require("chalk"));
var util = __importStar(require("util"));
var fs = __importStar(require("fs"));
/**
 * @description Method to display clean logs in terminal
 * @param type string the category to which statement belongs
 * @param description the statement to display in console
 * @param ?level to use to give hierarchy in logs
 * @example
 * [skipping] -| .git
 * [skipping] -| .gitignore
 * [indexing] -| file: ./LICENSE
 * [indexing] -| file: ./README.md
 */
exports.log = function (type, desc, level) {
    if (level === void 0) { level = 0; }
    var padding = " -";
    for (var i = 1; i <= level; i++) {
        padding += "-";
    }
    padding += "| ";
    console.log(chalk_1.default.bold("[") +
        chalk_1.default.italic.yellow(type) +
        chalk_1.default.bold("]") +
        padding +
        chalk_1.default.greenBright(desc));
};
/** using system calls with async/await */
exports.lstat = util.promisify(fs.lstat);
exports.readdir = util.promisify(fs.readdir);
exports.createFile = util.promisify(fs.writeFile);
/**
 * function to get file extension and type from name
 * @param fileName string filename to extract extension and filetype from
 */
exports.getFileType = function (fileName) {
    var images = ["png", "jpg", "gif", "img", "jpeg"];
    var documents = ["docx", "doc", "pdf", "xls", "xlsx", "md"];
    var compressed = ["zip", "tar", "gz", "iso", "rar", "7z"];
    var code = ["js", "json", "cpp", "java", "class", "ts", "php"];
    var extension = fileName.split(".").pop() || "txt";
    var fileType = "file";
    if (images.includes(extension)) {
        fileType = "image";
    }
    else if (documents.includes(extension)) {
        fileType = "document";
    }
    else if (compressed.includes(extension)) {
        fileType = "compressed";
    }
    else if (code.includes(extension)) {
        fileType = "code";
    }
    else {
        fileType = "file";
    }
    return {
        extension: extension,
        type: fileType,
    };
};
exports.GenerateUlLiFromTree = function (tree) {
    var ExportString = "";
    for (var i = 0; i < tree.length; i += 1) {
        if (tree[i].type == "leaf") {
            ExportString += "<li><a href=\"" + tree[i].location + "\">" + tree[i].name + "</a></li>";
        }
        else {
            ExportString += "<li>" + tree[i].name + "<li>\n      <ul>" + exports.GenerateUlLiFromTree(tree[i].children) + "</ul><br />";
        }
    }
    return ExportString;
};
